#!/usr/bin/python
# -*- coding:utf-8 -*-

"""Visualisation des solutions générées par 'puzzle.py'.
Usage :   ./visu.py [--stereo] fichier_de_points"""

__date__    = '2009-09-24'
__licence__ = 'Creative Commons Zero'

import sys
from visual import *

#------------------------------------------------------------------------------


# Initialisation
if len(sys.argv) not in [2,3]:
    print __doc__
    sys.exit(2)
COL = [ (), (1,1,1), (1,0,0), (0,0,1), (0,1,0), (1,1,0), (1,.5,0), (.4,.4,.4),
        (0,1,1), (1,0,1), (.5,0,1), (.5,1,0), (1,0,.5), (0,.5,1), (0,1,.5) ]
SIDE = 0.9
points = []


# Charger les points
try:
    for l in open(sys.argv[-1], 'r'):
        pt = map(int, l.split(','))
        if len(pt) != 4:
            if len(pt) == 3:
                p += [1]
            else:
                raise ValueError
        points.append(pt)
except:
    print >>sys.stderr, "ERREUR : fichier inaccessible ou mal construit"
    sys.exit(1)


# Passer de la base (x,z,y) à (x,y,z)
for pt in points:
    pt[1:3] = [pt[2], pt[1]]


# Trouver le centre géométrique de l'objet
moy = lambda x: ( max(x) + min(x) ) / 2.0
ct = tuple(moy([pt[i] for pt in points]) for i in xrange(3))


# Initialiser la scène
if "--stereo" in sys.argv:
    scene.stereo = 'redcyan'
scene.enable_shaders = 0
scene.background = color.black
scene.center = ct
scene.forward = (-1, 1, -1)
scene.up = (0, 0, 1)
scene.autoscale = 0
scene.range = 5


# Afficher l'objet
for pt in points:
    box(pos=tuple(pt[:3]), size=(SIDE,)*3, color=COL[pt[3]])


#------------------------------------------------------------------------------
